---
title: 'Date.prototype[@@toPrimitive]'
slug: Web/JavaScript/Reference/Global_Objects/Date/@@toPrimitive
tags:
  - Date
  - JavaScript
  - Method
  - Prototype
  - Reference
---
<div>{{JSRef}}</div>

<p>The <code><strong>[@@toPrimitive]()</strong></code> method converts a <code>Date</code> object to a primitive value.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">Date()[Symbol.toPrimitive](<var>hint</var>);</pre>

<h3 id="Return_value">Return value</h3>

<p>The primitive value of the given {{jsxref("Date")}} object. Depending on the argument, the method can return either a string or a number.</p>

<h2 id="Description">Description</h2>

<p>The <code>[@@toPrimitive]()</code> method of the {{jsxref("Date")}} object returns a primitive value, that is either of type number or of type string.</p>

<p>If <code><var>hint</var></code> is <code>string</code> or <code>default</code>, <code>[@@toPrimitive]()</code> tries to call the {{jsxref("Object.prototype.toString()", "toString")}} method. If the <code>toString</code> property does not exist, it tries to call the {{jsxref("Object.prototype.valueOf()", "valueOf")}} method and if the <code>valueOf</code> does not exist either, <code>[@@toPrimitive]()</code> throws a {{jsxref("TypeError")}}.</p>

<p>If <code>hint</code> is <code>number</code>, <code>[@@toPrimitive]()</code> first tries to call <code>valueOf</code>, and if that fails, it calls <code>toString</code>.</p>

<p>JavaScript calls the <code>[@@toPrimitive]()</code> method to convert an object to a primitive value. You rarely need to invoke the <code>[@@toPrimitive]()</code> method yourself; JavaScript automatically invokes it when encountering an object where a primitive value is expected.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Returning_date_primitives">Returning date primitives</h3>

<pre class="brush: js notranslate">const testDate = new Date(1590757517834);
// "Date Fri May 29 2020 14:05:17 GMT+0100 (British Summer Time)"

testDate[Symbol.toPrimitive]('string');
// Returns "Date Fri May 29 2020 14:05:17 GMT+0100 (British Summer Time)"

testDate[Symbol.toPrimitive]('number');
// Returns "1590757517834"

testDate[Symbol.toPrimitive]('default');
// Returns "Date Fri May 29 2020 14:05:17 GMT+0100 (British Summer Time)"</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-date.prototype-@@toprimitive', 'Date.prototype.@@toPrimitive')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Date.@@toPrimitive")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Symbol.toPrimitive")}}</li>
</ul>
